// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemFitsFileReaderWriterX.h     & XMM Science Analysis System (SAS) 
* 
* Class representing FITS file reader/writer.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemFitsReaderWriterX.h,v 1.5 2000/11/09 16:20:52 mthomas Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_FITS_FILE_READER_WRITERX_H
#define MEM_FITS_FILE_READER_WRITERX_H


#include "MemFitsReaderWriter.h"


class MemFitsReaderWriterX : public MemFitsReaderWriter
{
	public :

		//MemFitsReaderWriterX(){}
		//~MemFitsReaderWriterX(){}

		//void read( DataSet* dataSet );
		//void write( DataSet* dataSet );

	private :
		//int readColumn(
		//	fitsfile *	fptr,
		//	int &		columnNumber,
		//	Table &		table,
		//	int &		status ) const;
		//int readTable(
		//	fitsfile *	fptr,
		//	DataSet&	dataSet,
		//	int &		status ) const;

		Status columnDataTypeStatus( int typeCode ) const;

		bool acceptTableKeyword(
			fitsfile*	fptr,
			const string&	keyName ) const;

		void setColumnDataType( ColumnInfo& columnInfo ) const;
		Table* addTable(
			DataSet&				dataSet,
			TableInfo& 				tableInfo ) const;


};



#endif
