// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsaddarray
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Add an array to a dataset
	Description: Add an array to a dataset


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <dal_utilities.h>



#include "dsaddarray.h"

void dsaddarray()
{
  PROC
  const string		setName( stringParameter( "set" ));
  const string		name( stringParameter( "name" ));
  const string		type( stringParameter( "type" ));
  const vector<int>	s( intListParameter( "size" ) );
  longVec			size;
  for( unsigned int i = 0; i < s.size(); ++i ) size.push_back( s[ i ] );
  //const bool		withUnits( booleanParameter( "withunits" ) );
  const string		units( stringParameter( "units" ));
  //const bool		withLabel( booleanParameter( "withlabel" ) );
  const string		label( stringParameter( "label" ));
  const bool		withNull( booleanParameter( "withnull" ) );
  const int		nullValue( intParameter( "null" ) );
  //const bool		withData( booleanParameter( "data" ) );
  //const string		data( stringParameter( "data" ));
  const bool		withPosition( booleanParameter( "withposition" ) );
  int			position( intParameter( "position" ));
  
  DataSet*		dataSet( dataSetServer -> open( setName, DataSet::Modify ) );
  Array*			array;
  
  if( withPosition )
    {
      array = dataSet -> addArray( name, toDalDataType( type ), size, label, units, position );
    }
  else
    {
      array = dataSet -> addArray( name, toDalDataType( type ), size, label, units );
    }// if
  
  if( withNull )
    {
      array -> nullValue( nullValue );
    } // if
  
  dataSetServer -> close( dataSet );
  
  ENDPROC
}
