// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsattr
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Get attribute values
	Description: Get attribute values


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>


#include "dsattr.h"

void dsattr()
{
	PROC
	const vector<string>	attributes( stringListParameter( "attributes" ) );

	for( unsigned int i = 0; i < attributes.size(); ++i )
	{
		const string		name( attributes[ i ] );
		DataSet*		set( dataSetServer -> open( name, Dal::Read, DataSetServer::Low ) );
		const CompoundName	cn( name, CompoundName::AnyAttributeName, set );
		const Attributable*	attributable = cn.attributable();
		const Attribute*	attribute( attributable -> attribute( name ) );

		cout << *attribute << endl;
		dataSetServer -> close( set );
	} // for
	ENDPROC
}
