// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dscopyattr
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Copy a list of attributes to an attributable
	Description: Copy a list of attributes to an attributable


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>


#include "dscopyattr.h"

void dscopyattr()
{
	PROC
	const vector<string>	attributes( stringListParameter( "attributes" ) );
	string			to( stringParameter( "to" ) );
	DataSet*		dsnSet( dataSetServer -> open( to, Dal::Modify, DataSetServer::Low ) );
	CompoundName		dcn( to, CompoundName::AnyAttributableName, dsnSet );
	Attributable*		dsnAttributable = dcn.attributable();

	for( unsigned int i = 0; i < attributes.size(); ++i )
	{
		const string		name( attributes[ i ] );
		DataSet*		srcSet( dataSetServer -> open( name, Dal::Read, DataSetServer::Low ) );
		const CompoundName	scn( name, CompoundName::AnyAttributeName, srcSet );
		const Attributable*	srcAttributable = scn.attributable();
		const Attribute*	attribute( srcAttributable -> attribute( name ) );

		dsnAttributable -> addAttribute( attribute );
		dataSetServer -> close( srcSet );
	} // for
	dataSetServer -> close( dsnSet );
	ENDPROC
}
