// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dscopyblock
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Copy a list of blocks to a dataset
	Description: Copy a list of blocks to a dataset


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>


#include "dscopyblock.h"

void dscopyblock()
{
	PROC
	const vector<string>	blocks( stringListParameter( "blocks" ) );
	string			to( stringParameter( "to" ) );
	DataSet*		dsnSet( dataSetServer -> open( to, Dal::Modify ) );

	for( unsigned int i = 0; i < blocks.size(); ++i )
	{
		const string		name( blocks[ i ] );
		DataSet*		srcSet( dataSetServer -> open( name, Dal::Read ) );
		Block*			srcBlock( srcSet -> block( name ) );

		dsnSet -> add( srcBlock );
		dataSetServer -> close( srcSet );

	} // for
	dataSetServer -> close( dsnSet );
	ENDPROC
}
