// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dscopyrows
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Copy a range of rows in the given tables
	Description: Copy a range of rows in the given tables


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>


#include "dscopyrows.h"

void dscopyrows()
{
	PROC
	const string	table( stringParameter( "table" ) );
	const int	from( intParameter( "from" ) );
	const int	count( intParameter( "count" ) );
	const int	to( intParameter( "to" ) );

	DataSet*	set( dataSetServer -> open( table, Dal::Modify ) );
	Table*		tab( set -> table( table ) );

	tab -> copyRows( from, to, count );

	dataSetServer -> close( set );

	ENDPROC
}
