// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsinserttable
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Insert one table (source) into another (destination)
	Description: Insert one table (source) into another (destination)


*/

#include <Tracer.h>
// #include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <dal_utilities.h>
#include <CompoundName.h>



#include "dsinserttable.h"

void dsinserttable()
{
	PROC
	const string	srcTableName( stringParameter( "from" ));
	const int	fromRow( intParameter( "fromrow" ) );
	const int	toRow( intParameter( "torow" ) );
	const int	count( intParameter( "count" ) );
	const string	dtnTableName( stringParameter( "to" ));

	CompoundName	srcCn( srcTableName, CompoundName::TableName );
	CompoundName	dtnCn( dtnTableName, CompoundName::TableName, 0, Dal::Modify );

	insertTable( dtnCn.table(), toRow, srcCn.table(), fromRow, count );
	ENDPROC
}
