// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsvalidate
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Check a dataset.
	Description: Check a dataset using a template derived from the output from dstruct


*/

#include <Tracer.h>


#include "DataSetStruct.h"
#include "dsvalidate.h"

void dsvalidate()
{
	PROC
	const vector<string>	sets( stringListParameter( "sets" ) );
	const string		templateName( stringParameter( "template" ) );

	dataSetStructServer -> readDataSetStructs( templateName, false );
	DataSetStruct*	dataSetStruct = dataSetStructServer -> dataSetStruct( 0 );

	for( unsigned int i = 0; i < sets.size(); ++i )
	{
		const string		name( sets[ i ] );
		dataSetStruct -> name( name );
		dataSetStruct -> check();
	} // for
	dataSetStructServer -> releaseDataSetStructs();
	ENDPROC
}

